package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMORDENTRABAJO*/
@Entity(name="TarmOrdenTrabajo")
@Table(name="TARMORDENTRABAJO")
public class TarmOrdenTrabajo extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmOrdenTrabajo
*/
@Id
@Column(name="CORDENTRABAJO" ,nullable=false, updatable=false)
private Long pk;
@Column(name="CSOLICITUD", nullable=true)

/**
* Codigo de solicitud de controld e armas
*/
private String csolicitud;

@Column(name="CTRAMITE", nullable=true)

/**
* null
*/
private Long ctramite;

@Column(name="FSOLICITUD", nullable=true)

/**
* null
*/
private Date fsolicitud;

@Column(name="DOCUMENTOREFERENCIA", nullable=true)

/**
* null
*/
private String documentoreferencia;

@Column(name="EMPRESASOLICITA", nullable=true)

/**
* null
*/
private String empresasolicita;

@Column(name="DIRECCIONCOMISION", nullable=true)

/**
* null
*/
private String direccioncomision;

@Column(name="RUTA", nullable=true)

/**
* null
*/
private String ruta;

@Column(name="TIEMPOESTIMADO", nullable=true)

/**
* null
*/
private String tiempoestimado;

@Column(name="FINICIO", nullable=true)

/**
* null
*/
private Date finicio;

@Column(name="FFINALIZACION", nullable=true)

/**
* null
*/
private Date ffinalizacion;

@Column(name="OBSERVACIONES", nullable=true)

/**
* null
*/
private String observaciones;

/**Contructor por defecto*/
public TarmOrdenTrabajo(){
}
/**Contructor de TarmOrdenTrabajo
@param pPk Clave Primaria del entity
*/
public TarmOrdenTrabajo(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmOrdenTrabajo
*/
public static TarmOrdenTrabajo find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmOrdenTrabajo obj = pEntityManager.find(TarmOrdenTrabajo.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmOrdenTrabajo
@return El objeto que referencia a la Clave primaria de TarmOrdenTrabajo
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmOrdenTrabajo
@param pPk El objeto que referencia a la nueva Clave primaria de TarmOrdenTrabajo
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de ctramite
@return valor de ctramite*/
public Long getCtramite(){
  return ctramite;
}
/**Fija el valor de ctramite
@param pCtramite nuevo Valor de ctramite*/
public void setCtramite(Long pCtramite){
  ctramite=pCtramite;
}

/**Obtiene el valor de fsolicitud
@return valor de fsolicitud*/
public Date getFsolicitud(){
  return fsolicitud;
}
/**Fija el valor de fsolicitud
@param pFsolicitud nuevo Valor de fsolicitud*/
public void setFsolicitud(Date pFsolicitud){
  fsolicitud=pFsolicitud;
}

/**Obtiene el valor de documentoreferencia
@return valor de documentoreferencia*/
public String getDocumentoreferencia(){
  return documentoreferencia;
}
/**Fija el valor de documentoreferencia
@param pDocumentoreferencia nuevo Valor de documentoreferencia*/
public void setDocumentoreferencia(String pDocumentoreferencia){
  documentoreferencia=pDocumentoreferencia;
}

/**Obtiene el valor de empresasolicita
@return valor de empresasolicita*/
public String getEmpresasolicita(){
  return empresasolicita;
}
/**Fija el valor de empresasolicita
@param pEmpresasolicita nuevo Valor de empresasolicita*/
public void setEmpresasolicita(String pEmpresasolicita){
  empresasolicita=pEmpresasolicita;
}

/**Obtiene el valor de direccioncomision
@return valor de direccioncomision*/
public String getDireccioncomision(){
  return direccioncomision;
}
/**Fija el valor de direccioncomision
@param pDireccioncomision nuevo Valor de direccioncomision*/
public void setDireccioncomision(String pDireccioncomision){
  direccioncomision=pDireccioncomision;
}

/**Obtiene el valor de ruta
@return valor de ruta*/
public String getRuta(){
  return ruta;
}
/**Fija el valor de ruta
@param pRuta nuevo Valor de ruta*/
public void setRuta(String pRuta){
  ruta=pRuta;
}

/**Obtiene el valor de tiempoestimado
@return valor de tiempoestimado*/
public String getTiempoestimado(){
  return tiempoestimado;
}
/**Fija el valor de tiempoestimado
@param pTiempoestimado nuevo Valor de tiempoestimado*/
public void setTiempoestimado(String pTiempoestimado){
  tiempoestimado=pTiempoestimado;
}

/**Obtiene el valor de finicio
@return valor de finicio*/
public Date getFinicio(){
  return finicio;
}
/**Fija el valor de finicio
@param pFinicio nuevo Valor de finicio*/
public void setFinicio(Date pFinicio){
  finicio=pFinicio;
}

/**Obtiene el valor de ffinalizacion
@return valor de ffinalizacion*/
public Date getFfinalizacion(){
  return ffinalizacion;
}
/**Fija el valor de ffinalizacion
@param pFfinalizacion nuevo Valor de ffinalizacion*/
public void setFfinalizacion(Date pFfinalizacion){
  ffinalizacion=pFfinalizacion;
}

/**Obtiene el valor de observaciones
@return valor de observaciones*/
public String getObservaciones(){
  return observaciones;
}
/**Fija el valor de observaciones
@param pObservaciones nuevo Valor de observaciones*/
public void setObservaciones(String pObservaciones){
  observaciones=pObservaciones;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmOrdenTrabajo))return false;
    TarmOrdenTrabajo that = (TarmOrdenTrabajo) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmOrdenTrabajo
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmOrdenTrabajo
*/
public Object createInstance(){
 TarmOrdenTrabajo instance=new TarmOrdenTrabajo();	
 return instance;
}
/**Clona la entidad TarmOrdenTrabajo
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmOrdenTrabajo p=(TarmOrdenTrabajo)this.clone();
  return p;
}
}
